import java.util.concurrent.ThreadLocalRandom;

public abstract class Mutex {

	public static void criticalSection(String mark) {
		try {
			int maxIter = 10;
			int minIter = 1;

			int rdIter = ThreadLocalRandom.current().nextInt(minIter, maxIter + 1);
			
			System.out.println("^");
			for (int k = 0; k < maxIter; k++) {
				System.out.println(mark);
				Thread.sleep(500);
			}
			System.out.println("v");
		}
		catch (InterruptedException e) {
			// Nothing
		}
	}

	public static void nonCriticalSection() {
		try {
			Thread.sleep((int) (Math.random() * 3000));
		}
		catch (InterruptedException e) {
			// Nothing
		}
	}

	// Take ownership
	public abstract void p(int id);

	// Release ownership
	public abstract void v(int id);
}
